<!--
Copyright (C) 2021-2024 Bundesministerium des Innern und für Heimat, Referat DG II 6, Maßnahmen Enterprise Resource Management und Elektronische Verwaltungsarbeit

SPDX-License-Identifier: MPL-2.0
-->

<!DOCTYPE html>
<html lang="de">
<head>
    <meta charset="UTF-8"/>
    <title>Synopse: Entwicklertool</title>
    <style>
        #synopsis {
            border-collapse: collapse;
            margin-left: auto;
            margin-right: auto;
        }

        #synopsis th,
        #synopsis td {
            border: 1px solid black;
            padding: 15px;
        }

        h1 {
            width: 100%;
            text-align: center;
        }

        body {
            font-family: Arial, Helvetica, sans-serif;
        }

        td > div {
            width: 460px;
            height: 180px;
            padding: 10px;
            border-radius: 0.5em;
        }

        .tile {
            cursor: grab;
            height: 210px;
        }

        .tileHeader {
            height: 85px;
            border-bottom-width: 1px;
            border-bottom-style: dotted;
            padding-bottom: 10px;
        }

        .tileText {
            height: max-content;
            vertical-align: bottom;
        }

        .matched {
            border: 3px solid gray;
        }

        .deleted{
            border: 3px solid red;
        }

        .added {
            border: 3px solid green;
        }

        .empty {
            border: 3px dashed black;
        }

        th.base,
        .base > div {
            background-color: bisque;
        }

        th.version,
        .version > div {
            background-color: lemonchiffon;
        }

        .elemGuid,
        .elemEId {
            display: block;
            text-align: right;
        }

        .elemType,
        .elemMark,
        .refGuid {
            display: block;
            text-align: left;
        }

        .elemType {
            font-weight: bold;
        }
    </style>
    <script>
        document.addEventListener("DOMContentLoaded", (e) => {
            function handleDragStart(e, node) {
                dragSource = node;
                e.dataTransfer.effectAllowed = "move";
                e.dataTransfer.setData("text/html", node.innerHTML);
            }

            function handleDragEnd(e, node) {
                console.log("dragEnd");
                node.style.opacity = "1.0";
            }

            function handleDragOver(e, node) {
                e.preventDefault();
                return false;
            }

            function handleDrop(e, node) {
                e.stopPropagation(); // stops the browser from redirecting
                e.preventDefault();
                if (canMove(dragSource, node)) {
                    console.log("can drop");
                    dragSource.innerHTML = node.innerHTML;
                    node.innerHTML = e.dataTransfer.getData("text/html");
                } else {
                    console.log("no go");
                }
                return false;
            }

            function canMove(source, target) {
                if (source !== target) {
                    return ((source.classList.contains("base") && target.classList.contains("base"))
                        || (source.classList.contains("version") && target.classList.contains("version")));
                } else {
                    return false;
                }
            }

            let dragSource;
            let draggableItems = document.querySelectorAll(".tile");
            draggableItems.forEach(function (item) {
                item.addEventListener("dragstart", (e) => handleDragStart(e, item));
                item.addEventListener("dragend", (e) => handleDragEnd(e, item));
                item.addEventListener("dragover", (e) => handleDragOver(e, item));
                item.addEventListener("drop", (e) => handleDrop(e, item));
            });
        });
    </script>
</head>
<body>
<h1>Synopse</h1>
<table id="synopsis">
    <caption></caption>
    <thead>
    <tr>
        <th class="base">BASE</th>
        <th class="version">VERSION</th>
    </tr>
    </thead>
    <tbody>
    ✄
    </tbody>
</table>
</body>
</html>
